#|					;

blueberry/theme.jl
Copyright (C) 2000 Isaac Feitler (ike@freeshell.org)
this theme was first created by tinkering with gradient/theme.jl ,
which is  Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>
Since those early tinkerings, this theme has changed alot, using
code from many other themes.

This file is written to work with sawfish.

sawfish is free software		; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation		; either version 2, or (at your option)
any later version.

sawfish is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY			; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sawmill			; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

Commentary:
bevels should be set to 0 for this to look right.
I wanted to learn to make a theme and do cool stuff.
I wanted to make sawmill look like my old fvwm2 configuration
but better

uses code from 'gradient', 'brain', 'clean-gtk', and an idea/code 
from 'FlatSaw'  and 'think'

todo: cleanup the code even more, someday!

|#
;;;;;;;;;;;requirements
(require 'gradient)
(require 'rep.io.timers)
;;;;;;;;;;mad customization
(define (recreate-all-frames foo)
  (sleep-for 1)
  (reframe-windows-with-style 'blueberry))

(defgroup blueberry "blueberry")

;;;;;;;;;;;
(defgroup fonts "fonts" :group blueberry)

(defcustom blueberry:title-font (get-font "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1")
  "default font for blueberry theme"
  :type font
  :group (blueberry fonts)
  :after-set recreate-all-frames)

(defcustom blueberry:active-font-color (get-color "#aaccff")
  "font color in active titles -- needs restart "
  :type color
  :group (blueberry fonts)
  :after-set recreate-all-frames)

(defcustom blueberry:inactive-font-color (get-color "#bbbbbb")
  "font color in inactive titles -- needs restart "
  :type color
  :group (blueberry fonts)
  :after-set recreate-all-frames)

(defcustom blueberry:highlighted-font-color (get-color "#aaccff")
  "font color in highlighted titles -- needs restart "
  :type color
  :group(blueberry  fonts)
  :after-set recreate-all-frames)

(defcustom blueberry:clicked-font-color (get-color "#aaccff")
  "font color in clicked titles -- needs restart "
  :type color
  :group(blueberry  fonts)
  :after-set recreate-all-frames)
;;;;;;;;;;;;


;;;;;;;;;;;
(defgroup button-colors "button-colors" :group blueberry)

(defcustom blueberry:active-menu-button-color (get-color "#0000cc")
  "button color in active titles -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:inactive-menu-button-color (get-color "#7777dd")
  "button color in inactive titles -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:highlighted-menu-button-color (get-color "#4444cc")
  "button color on mouseover -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:clicked-menu-button-color (get-color "#0000cc")
  "button color when clicked -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:active-button-color (get-color "#aaccff")
  "button color in active titles -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:inactive-button-color (get-color "#bbbbbb")
  "button color in inactive titles -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:highlighted-button-color (get-color "#33ff77")
  "button color on mouseover -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)

(defcustom blueberry:clicked-button-color (get-color "#33ff77")
  "button color when clicked -- needs restart "
  :type color
  :group (blueberry button-colors)
  :after-set recreate-all-frames)
;;;;;;;;;;;;


;;;;;;;;;;;;
(defgroup gradients "gradients" :group blueberry)


(defcustom gradients:gradient-type 'vertical
  "Direction of gradient in `blueberry' frame style."
  :type symbol
  :options (horizontal vertical diagonal)
  :group (blueberry gradients)
  :after-set recreate-all-frames)

(defcustom gradients:normal-from-color (get-color "#444499")
  "`From' color of inactive frames in `blueberry' frame style."
  :type color
  :group (blueberry gradients)
  :after-set recreate-all-frames)

(defcustom gradients:normal-to-color (get-color "#7777dd")
  "`To' color of inactive frames in `blueberry' frame style."
  :type color
  :group (blueberry gradients)
  :after-set recreate-all-frames)

(defcustom gradients:active-from-color (get-color "#221180")
  "`From' color of active frames in `blueberry' frame style."
  :type color
  :group (blueberry gradients)
  :after-set recreate-all-frames)

(defcustom gradients:active-to-color (get-color "#8888ff")
  "`To' color of active frames in `blueberry' frame style."
  :type color
  :group (blueberry gradients)
  :after-set recreate-all-frames)


(defcustom gradients:save-memory nil
  "Use less memory when creating gradients, possibly affecting quality."
  :type boolean
  :group (blueberry gradients)
  :after-set recreate-all-frames)
;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;
(defgroup borders "borders" :group blueberry)

(defcustom borders:border-width '7
  "width of borders around the window -- needs restart "
  :type number
  :group (blueberry borders)
  :range (1 . 25)
  :after-set recreate-all-frames)

(defcustom borders:active-border-color gradients:active-from-color
  "color of active top borders -- needs restart "
  :type color
  :group (blueberry borders)
  :after-set recreate-all-frames)

(defcustom borders:normal-border-color gradients:normal-from-color
  "color of inactive top borders -- needs restart "
  :type color
  :group (blueberry borders)
  :after-set recreate-all-frames)
;;;;;;;;;;;;
(defgroup 3d-borders "3d-borders" :group blueberry)

(defcustom 3d-borders:show-3d-borders t
  "blueberry can make 3d-ish borders 
ala fvwm, mwm, etc. by modifiying 
the color of the top border and 
drawing some lines. if you don't want
them, uncheck this to turn it off"
  :type boolean
  :group (blueberry 3d-borders)
  :after-set recreate-all-frames)

(defcustom 3d-borders:hi-color-modifier 30000
  "amount by which to brighten 
the top-border color to create 
`3d' borders this may take some
experimentation if you don't 
like the default -- needs restart"
  :type number
  :range (-40000 . 40000)
  :group (blueberry 3d-borders)
  :after-set recreate-all-frames)

(defcustom 3d-borders:lo-color-modifier -3000
  "amount by which to brighten 
the top-border color to create 
`3d' borders this may take some
experimentation if you don't 
like the default -- needs restart"
  :type number
  :range (-40000 . 40000)
  :group (blueberry 3d-borders)
  :after-set recreate-all-frames)

;;;;;;;;;;;;
(defgroup clock "clock" :group blueberry)

(defcustom clock:show t
  "show the clock -- needs restart "
  :type boolean
  :group (blueberry clock)
  :after-set recreate-all-frames)

(defcustom clock:update-all ()
  "update the clock in all windows instead
of just the focused one -- needs restart "
  :type boolean
  :group (blueberry clock)
  :after-set recreate-all-frames)

;;;;;;;;;;;;

;;code from gradient
(define render-bg 
  (lambda (img state)
    (apply (cond ((eq gradients:gradient-type 'diagonal)
		  draw-diagonal-gradient)
		 ((eq gradients:gradient-type 'horizontal)
		  draw-horizontal-gradient)
		 ((eq gradients:gradient-type 'vertical)
		  draw-vertical-gradient))
	   img (if state
		   (list gradients:active-from-color
			 gradients:active-to-color)
		 (list gradients:normal-from-color
		       gradients:normal-to-color)))
    (when (> (cdr (image-dimensions img)) 4)
      (bevel-image img 1 (not (eq state 'clicked))))
    (set-image-border img 1 1 1 1)))

(define scale 
  (lambda () (if gradients:save-memory 2 1)))
     
;;brand new shiny (as of 12-1-02000) recolor image function.
(define recolor-image 
  (lambda (image color)
    (when (and (imagep image) (colorp color))
      (let*
	  ((rgb (color-rgb-8 color))
	   (red (nth 0 rgb))
	   (green (nth 1 rgb))
	   (blue (nth 2 rgb)))
	(define (transform old-pixel)
	  (and (> (nth 3 old-pixel) 0)
	       (mapcar (lambda (x) (max x 0))
		       (list (- (nth 1 old-pixel) (- 255 red))
			     (- (nth 2 old-pixel) (- 255 green))
			     (- (nth 0 old-pixel) (- 255 blue))
			     255)
		       )
	       ))
	(image-map transform image))
      image)))

;;code from somewhere else, modified.
(define title-width
  (lambda (w)
    (+ 30 (text-width (window-full-name w) blueberry:title-font))))

(define update-title-width
  (lambda (w)
    (if (eq (window-get w 'current-frame-style) 'blueberry) 
	(rebuild-frame w))))


;;code from brain (modified)
(define title-string 
  (lambda (w) 
    (let ((w-id (window-id w))) 
      (window-name w)))) 





#|					;
;;old, no longer needed code now that I've figured out how to update 
;;just one part at a time 
;;***
;;update only focused title?
(define update-focused
  (lambda (timer)
    (if (input-focus)
	(rebuild-frame (input-focus)))
    (set-timer timer)))
|#

;;my own code, perhaps inspired by brain
(define border-top-edge
  (lambda (w)
    (if (eq 'default (window-type w)) 
	(- -6 (+ borders:border-width (font-height blueberry:title-font)))
      (- 0  borders:border-width)
      )))

(define title-top-edge
  (lambda (w)
    (min -16 
	 (- -6 (font-height blueberry:title-font)))))

;;my own code to alter-color objects- for making 3d borders
(define modify-color 
  (lambda (color rdelta gdelta bdelta)
    (get-color-rgb (+ rdelta (car (color-rgb color)))
		   (+ gdelta (cadr (color-rgb color)))
		   (+ bdelta (car (cddr (color-rgb color))))
		   )))

     ;;;;;;;;;;;;;;;;;;;;;;;;
;;using modify-color
(define 3d-hi-border-color 
  (modify-color
   borders:active-border-color
   3d-borders:hi-color-modifier
   3d-borders:hi-color-modifier
   3d-borders:hi-color-modifier))
(define 3d-lo-border-color 
  (modify-color
   borders:normal-border-color
   3d-borders:lo-color-modifier
   3d-borders:lo-color-modifier
   3d-borders:lo-color-modifier))
;; font colors. yum.
(define font-colors (list blueberry:inactive-font-color
			  blueberry:active-font-color
			  blueberry:highlighted-font-color
			  blueberry:clicked-font-color))
     ;;;;FRAME PARTS! 
     ;;;;;;;;;;;;;;;;
;; buttons
;;menu button -- code adjusted from code in RedMonk
(define default-images 
  (list (recolor-image 
	  (make-image "yybw-n.png")
	  blueberry:inactive-menu-button-color )
	(recolor-image 
	  (make-image "yybw.png")
	  blueberry:active-menu-button-color )
	(recolor-image 
	  (make-image "yybw.png")
	  blueberry:highlighted-menu-button-color )
	(recolor-image 
	  (make-image "yybw-c.png")
	  blueberry:clicked-menu-button-color )))
;;;  
(define win-icon-or-yys 
    (lambda (w)
      (let ((icon (window-icon-image w)))
	(if icon (list icon) default-images))))


(define menupopb `((background .  ,win-icon-or-yys)
		   (left-edge . 3)
		   (top-edge . ,title-top-edge)
		   (width . 16)
		   (height . 16)
		   (class . menu-button)
		   (removable . t)))
;;minimize button
(define minimizeb `((renderer . ,render-bg)
		    (foreground . (,(recolor-image 
				     (make-image "min.png") 
				     blueberry:inactive-button-color) 
				   ,(recolor-image 
				     (make-image "min.png") 
				     blueberry:active-button-color)
				   ,(recolor-image 
				     (make-image "min.png") 
				     blueberry:highlighted-button-color )
				   ,(recolor-image 
				     (make-image "min-c.png")
				     blueberry:clicked-button-color )))
		    (width . ,(car (image-dimensions (make-image "min.png"))))
		    (height . ,(cdr (image-dimensions (make-image "min.png"))))
		    (right-edge . 46)
		    (top-edge . ,title-top-edge)
		    (y-justify . center)
		    (class . iconify-button)
		    (removable . t)))
;;maximize button
(define maximizeb `((renderer . ,render-bg)
		    (foreground . (,(recolor-image 
				     (make-image "max.png") 
				     blueberry:inactive-button-color ) 
				   ,(recolor-image 
				     (make-image "max.png") 
				     blueberry:active-button-color )
				   ,(recolor-image 
				     (make-image "max.png") 
				     blueberry:highlighted-button-color )
				   ,(recolor-image 
				     (make-image "max-c.png")
				     blueberry:clicked-button-color )))
		    (width . ,(car (image-dimensions (make-image "max.png"))))
		    (height . ,(cdr (image-dimensions (make-image "max.png"))))
		    (right-edge . 25)
		    (top-edge . ,title-top-edge)
		    (class . maximize-button)
		    (removable . t)))

;;close button
(define closeb `((renderer . ,render-bg)
		 (foreground . (,(recolor-image 
				  (make-image "close.png") 
				  blueberry:inactive-button-color ) 
				,(recolor-image 
				  (make-image "close.png") 
				  blueberry:active-button-color )
				,(recolor-image 
				  (make-image "close.png") 
				  blueberry:highlighted-button-color )
				,(recolor-image 
				  (make-image "close-c.png")
				  blueberry:clicked-button-color )))
		 (width . ,(car (image-dimensions (make-image "close.png"))))
		 (height . ,(cdr (image-dimensions (make-image "close.png"))))
		 (right-edge . 4)
		 (top-edge . ,title-top-edge)
		 (class . close-button)
		 (removable . t)))

;;funny font thing from brain -- but it works,
;;saving the user from a restart when trying fonts!
(define title-font (lambda () blueberry:title-font))

;;title background
(define title-bg `((renderer . ,render-bg)
		   (render-scale . ,scale)
		   (left-edge . 0)
		   (right-edge .  0)
		   (top-edge . ,title-top-edge)
		   (height . ,(lambda (w)
				(- 0 (title-top-edge w))))
		   (class . title)))

;;clock
(def-frame-class title-clock '((cursor . left_ptr)) 
  (setq title-clock-keymap 'title-keymap)
	)

(define clock (if clock:show
		  `((renderer . ,render-bg)
		    (render-scale . ,scale)
		    (font . ,title-font)
		    (foreground . ,font-colors)
		    (text . ,current-time-string)
		    (x-justify . 0)
		    (y-justify . 1)
		    (width . ,(+ 12 (text-width (current-time-string blueberry:title-font))))
		    (right-edge . 60)
		    (top-edge . ,title-top-edge)
		    (height . ,(lambda (w)
				 (- 0 (title-top-edge w))))
		    (class . title-clock))
		nil))

;;clock update code?
(define update-focused-clock
  (lambda (timer)
    (if (input-focus)
	(map-frame-parts
	 (lambda (part)
	   (if (eq 'title-clock (frame-part-get part 'class))
	       (refresh-frame-part part)))
	 (input-focus)))
    (set-timer timer)))
;;code from Ryan Pavlik - no longer needed
;;(define update-all-titles
;;  (lambda (timer)
;;    (mapc update-title-width (managed-windows))
;;   (set-timer timer)))    
;;modified to update only the clocks in all the windows
(define update-all-clocks
  (lambda (timer)
    (mapc
     (lambda (w)
       (map-frame-parts
	(lambda (part)
	  (if (eq 'title-clock (frame-part-get part 'class))
	      (refresh-frame-part part)))
	w))
     (managed-windows))
    (set-timer timer)))  
      
     
;;title bar
(define title-bar `((renderer . ,render-bg)
		    (render-scale . ,scale)
		    (font . ,title-font)
		    (foreground . ,font-colors)
		    (text . ,window-name)
		    (x-justify . 23)
		    (y-justify . 1)
		    (left-edge . 0)
		    ;;realization of how to do the below cool thing 
		    ;;owed to FlatSaw, a really awesome theme, as well as think
		    (width . ,title-width)
		    (top-edge . ,title-top-edge)
		    (height . ,(lambda (w)
				 (- 0 (title-top-edge w))))
		    (class . title)))

;;borders
     
;;top border
(define top-border `((background . (,borders:normal-border-color
				    ,borders:active-border-color nil nil))
		     (left-edge . 0)
		     (right-edge . 0)
		     (top-edge . ,border-top-edge)
		     (height . ,borders:border-width)
		     (class . top-border)
		     ))

;;left border
(define left-border `((renderer . ,render-bg)
		      (left-edge . ,(- 0 borders:border-width))
		      (width . ,borders:border-width)
		      (top-edge . ,border-top-edge)
		      (class . left-border)
		      (bottom-edge . ,(- 0 borders:border-width))))
;;right border
(define right-border `((renderer . ,render-bg)
		       (right-edge . ,(- 0 borders:border-width))
		       (width . ,borders:border-width)
		       (top-edge . ,border-top-edge)
		       (class . right-border)
		       (bottom-edge . ,(- 0 borders:border-width))
		       
		       ))

;;bottom border
(define bottom-border `((renderer . ,render-bg)
			(render-scale . ,scale)
			(left-edge . 0)
			(right-edge . 0)
			(bottom-edge . ,(- 0 borders:border-width))
			(height . ,borders:border-width)
			(class . bottom-border)
			))
;;3d borders :) -to make the windows show up better, and for something like
;;that good 'ol fvwm2 feel

;;3d-top-border
(define 3d-top-border (if 3d-borders:show-3d-borders
			  `((background . ,3d-hi-border-color) 
			    (left-edge . ,(- 0 borders:border-width))
			    (right-edge . ,(- 0 borders:border-width))
			    (top-edge . ,border-top-edge)
			    (height . 1)
			    (class . top-border))
			nil))
(define 3d-left-border (if 3d-borders:show-3d-borders
			   `((background . ,3d-hi-border-color) 
			     (left-edge . ,(- 0 borders:border-width))
			     (width . 1)
			     (top-edge . ,border-top-edge)
			     (class . left-border)
			     (bottom-edge . ,(- 0 borders:border-width)))
			 nil))
(define 3d-right-border (if 3d-borders:show-3d-borders
			    `((background . ,3d-lo-border-color)
			      (right-edge . ,(- 0 borders:border-width))
			      (width . 1)
			      (top-edge . ,border-top-edge)
			      (class . right-border)
			      (bottom-edge . ,(- 0 borders:border-width)))
			  nil))
(define 3d-bottom-border (if 3d-borders:show-3d-borders
			     `((background . ,3d-lo-border-color)
			       (render-scale . ,scale)
			       (left-edge . ,(- 0 borders:border-width))
			       (right-edge . ,(- 0 borders:border-width))
			       (bottom-edge . ,(- 0 borders:border-width))
			       (height . 1)
			       (class . bottom-border))
			   nil))     

    
(define frame `(
		;;drawing order is important for narrow windows
	           
		,title-bg
		,clock
		,minimizeb
		,maximizeb
		,title-bar
		,menupopb
		,closeb
		;;top border
		,top-border
		;;left border
		,left-border
		;;right border
		,right-border
		;;bottom border
		,bottom-border
		;;3d borders
		,3d-top-border
		,3d-left-border
		,3d-right-border
		,3d-bottom-border

		))
(define shaped-frame `(;;same order for shaped
		       ,title-bg
		       ,clock
		       ,minimizeb
		       ,maximizeb
		       ,title-bar
		       ,menupopb
		       ,closeb
		     
		       ))
     
(define transient-frame `(
			  ;;top border
			  ,top-border
			  ;;left border
			  ,left-border
			  ;;right border
			  ,right-border
			  ;;bottom-border
			  ,bottom-border
			  ;;3d borders
			  ,3d-top-border
			  ,3d-left-border
			  ,3d-right-border
			  ,3d-bottom-border))
     
(define shaped-transient-frame `(
				 ;;top border
				 ,top-border
				 ,3d-top-border)) 

(define nil-frame `())
  
(add-frame-style 'blueberry
		 (lambda (w type)
		   (case type
		     ((default) frame)
		     ((shaped) shaped-frame)
		     ((transient) transient-frame)
		     ((shaped-transient) shaped-transient-frame)
		     ((unframed) nil-frame))))
  

;;I haven't been able to figure out where this 
;;line originates... but it is responsible for a lot of themes working!

;;needs WM_NAME for title to work
(call-after-property-changed (list 'WM_NAME) update-title-width)
;;timer code from Ryan Pavlik

(if clock:update-all
    (if clock:show (make-timer update-all-clocks 1))
  (if clock:show (make-timer update-focused-clock 1)))

;;this code will not work with versions less than 0.25.2...
;;this is because in version 0.25.2 and greater, you can groovily
;;update only the focused window, which may make the
;;cpu load manageable.

;;otherwise it works but it is indeed somewhat CPU intensive...
